<?php
	abstract class __forget_users {
		public function forget($template = "default") {
			list($template_block) = def_module::loadTemplates("tpls/users/forget/{$template}.tpl", "forget_block");
			$block_arr = Array();
			return def_module::parseTemplate($template_block, $block_arr);
		}


		public function forget_do($template = "default") {
			static $macrosResult;
			if($macrosResult) return $macrosResult;
			$forget_login = getRequest('forget_login');
			$forget_email = getRequest('forget_email');

			if($forget_email === NULL) {
				$hasLogin = true;
				$hasEmail = false;
				$forget_login = (string) $forget_login;
			}
			if($forget_login === NULL) {
				$hasLogin = false;
				$hasEmail = true;
				$forget_email = (string) $forget_email;
			}

			$oldTemplaterMode = xslTemplater::getInstance()->setIsInited(false);
			list(
				$template_wrong_login_block, $template_forget_sended, $template_mail_verification, $template_mail_verification_subject
			) = def_module::loadTemplates("tpls/users/forget/{$template}.tpl",
				"wrong_login_block", "forget_sended", "mail_verification", "mail_verification_subject"
			);

			xslTemplater::getInstance()->setIsInited($oldTemplaterMode);

			if($hasLogin || $hasEmail) {
				$sel = new selector('objects');
				$sel->types('object-type')->name('users', 'user');
				if($hasLogin) $sel->where('login')->equals($forget_login);
				if($hasEmail) $sel->where('e-mail')->equals($forget_email);
				$sel->limit(0, 1);

				if($sel->first) {
					$user_id = $sel->first->id;
				} else {
					$user_id = false;
				}
			} else {
				$user_id = false;
			}

			if($user_id) {
				$activate_code = md5(self::getRandomPassword());

				$object = umiObjectsCollection::getInstance()->getObject($user_id);

				$regedit = regedit::getInstance();
				$without_act = (bool) $regedit->getVal("//modules/users/without_act");
				if ($without_act || intval($object->getValue('is_activated'))) {
					$object->setValue("activate_code", $activate_code);
					$object->commit();

					$email = $object->getValue("e-mail");
					$fio = $object->getValue("lname") . " " . $object->getValue("fname") . " " . $object->getValue("father_name");

					$email_from = regedit::getInstance()->getVal("//settings/email_from");
					$fio_from = regedit::getInstance()->getVal("//settings/fio_from");

					$mail_arr = Array();
					$mail_arr['domain'] = $domain = $_SERVER['HTTP_HOST'];
					$mail_arr['restore_link'] = "http://" . $domain . $this->pre_lang . "/users/restore/" . $activate_code . "/";

					$oldTemplaterMode = xslTemplater::getInstance()->setIsInited(false);
					$mail_content = def_module::parseTemplate($template_mail_verification, $mail_arr, false, $user_id);
					xslTemplater::getInstance()->setIsInited($oldTemplaterMode);

					$someMail = new umiMail();
					$someMail->addRecipient($email, $fio);
					$someMail->setFrom($email_from, $fio_from);
					$someMail->setSubject($template_mail_verification_subject);
					$someMail->setPriorityLevel("highest");
					$someMail->setContent($mail_content);
					$someMail->commit();
					$someMail->send();

					$oEventPoint = new umiEventPoint("users_restore_password");
					$oEventPoint->setParam("user_id", $user_id);
					$this->setEventPoint($oEventPoint);

					$block_arr = Array();
					$block_arr['attribute:status'] = "success";
					return $macrosResult = def_module::parseTemplate($template_forget_sended, $block_arr);
				} else {
					$referer_url = getServer('HTTP_REFERER');
					if (!strlen($referer_url)) $referer_url = $this->pre_lang . "/users/forget/";
					$this->errorRegisterFailPage($referer_url);
					$this->errorNewMessage("%errors_forget_nonactivated_login%");
					$this->errorPanic();

					$block_arr = Array();
					$block_arr['attribute:status'] = "fail";
					$block_arr['forget_login'] = $forget_login;
					$block_arr['forget_email'] = $forget_email;
					return $macrosResult = def_module::parseTemplate($template_wrong_login_block, $block_arr);
				}
			} else {
				$referer_url = getServer('HTTP_REFERER');
				if (!strlen($referer_url)) $referer_url = $this->pre_lang . "/users/forget/";
				$this->errorRegisterFailPage($referer_url);
				if($hasLogin) $this->errorNewMessage("%errors_forget_wrong_login%");
				if($hasEmail) $this->errorNewMessage("%errors_forget_wrong_email%");
				$this->errorPanic();

				$block_arr = Array();
				$block_arr['attribute:status'] = "fail";
				$block_arr['forget_login'] = $forget_login;
				$block_arr['forget_email'] = $forget_email;
				return $macrosResult = def_module::parseTemplate($template_wrong_login_block, $block_arr);
			}
		}


		public function restore($template = "default", $activate_code = false) {
			static $result = Array();

			if(isset($result[$template])) {
				return $result[$template];
			}

			$oldTemplaterMode = xslTemplater::getInstance()->setIsInited(false);
			list($template_restore_failed_block, $template_restore_ok_block, $template_mail_password, $template_mail_password_subject) = def_module::loadTemplates("tpls/users/forget/{$template}.tpl", "restore_failed_block", "restore_ok_block", "mail_password", "mail_password_subject");
			xslTemplater::getInstance()->setIsInited($oldTemplaterMode);

			if(!$activate_code) {
				$activate_code = (string) getRequest('param0');
				$activate_code = trim($activate_code);
			}

			$object_type_id = umiObjectTypesCollection::getInstance()->getBaseType("users", "user");
			$object_type = umiObjectTypesCollection::getInstance()->getType($object_type_id);
			$activate_code_field_id = $object_type->getFieldId("activate_code");

			$sel = new selector('objects');
			$sel->types('object-type')->name('users', 'user');
			$sel->where('activate_code')->equals($activate_code);
			$sel->limit(0, 1);


			if($sel->first) {
				$object = $sel->first;
				$user_id = $object->id;
			} else {
				$object = false;
				$user_id = false;
			}

			$block_arr = Array();

			if($user_id && $activate_code) {
				$password = self::getRandomPassword();

				$login = $object->getValue("login");
				$email = $object->getValue("e-mail");
				$fio  = $object->getValue("lname") . " " . $object->getValue("fname") . " " . $object->getValue("father_name");

				$object->setValue("password", md5($password));
				$object->setValue("activate_code", "");
				$object->commit();

				$email_from = regedit::getInstance()->getVal("//settings/email_from");
				$fio_from = regedit::getInstance()->getVal("//settings/fio_from");

				$mail_arr = Array();
				$mail_arr['domain'] = $domain = $_SERVER['HTTP_HOST'];
				$mail_arr['password'] = $password;

				$oldTemplaterMode = xslTemplater::getInstance()->setIsInited(false);
				$mail_content = def_module::parseTemplate($template_mail_password, $mail_arr, false, $user_id);
				xslTemplater::getInstance()->setIsInited($oldTemplaterMode);

				$someMail = new umiMail();
				$someMail->addRecipient($email, $fio);
				$someMail->setFrom($email_from, $fio_from);
				$someMail->setSubject($template_mail_password_subject);
				$someMail->setContent($mail_content);
				$someMail->commit();
				$someMail->send();

				$block_arr['attribute:status'] = "success";
				$block_arr['login'] = $login;
				$block_arr['password'] = $password;
				return $result[$template] = def_module::parseTemplate($template_restore_ok_block, $block_arr, false, $user_id);
			} else {
				$block_arr['attribute:status'] = "fail";
				return $result[$template] = def_module::parseTemplate($template_restore_failed_block, $block_arr);
			}
		}


		public static function getRandomPassword ($length = 12) {
			$avLetters = "$#@^&!1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM";
			$size = strlen($avLetters);


			$npass = "";
			for($i = 0; $i < $length; $i++) {
				$c = rand(0, $size - 1);
				$npass .= $avLetters[$c];
			}
			return $npass;
		}
	};

?>